---
type: api
title: Update field mappings
description: **All methods and paths for this operation:**
url: https://www.elastic.co/elastic/docs-builder/docs/4493/api/doc/elasticsearch/v8/operation/operation-indices-put-mapping
resource: https://www.elastic.co/elastic/docs-builder/docs/4493/api/doc/elasticsearch/v8/operation/operation-indices-put-mapping
products:
  - Elasticsearch
---

# Update field mappings


## Paths

- `POST` (also `PUT`) `/{index}/_mapping`

#### Path parameters

- `index` (union string | string[]) — required
  A comma-separated list of index names the mapping should be added to (supports wildcards).
Use `_all` or omit to add the mapping on all indices.

## Description

Add new fields to an existing data stream or index.
You can also use this API to change the search settings of existing fields and add new properties to existing object fields.
For data streams, these changes are applied to all backing indices by default.

**Add multi-fields to an existing field**

Multi-fields let you index the same field in different ways.
You can use this API to update the fields mapping parameter and enable multi-fields for an existing field.
WARNING: If an index (or data stream) contains documents when you add a multi-field, those documents will not have values for the new multi-field.
You can populate the new multi-field with the update by query API.

**Change supported mapping parameters for an existing field**

The documentation for each mapping parameter indicates whether you can update it for an existing field using this API.
For example, you can use the update mapping API to update the `ignore_above` parameter.

**Change the mapping of an existing field**

Except for supported mapping parameters, you can't change the mapping or field type of an existing field.
Changing an existing field could invalidate data that's already indexed.

If you need to change the mapping of a field in a data stream's backing indices, refer to documentation about modifying data streams.
If you need to change the mapping of a field in other indices, create a new index with the correct mapping and reindex your data into that index.

**Rename a field**

Renaming a field would invalidate data already indexed under the old field name.
Instead, add an alias field to create an alternate field name.

[Read the reference documentation](https://www.elastic.co/guide/en/elasticsearch/reference/8.19/mapping-params.html)

## Required authorization

- Index privileges: `manage`

## Authentication

- Api key: `Authorization: <value>`
  Elasticsearch APIs support key-based authentication.
  You must create an API key and use the encoded value in the request header.
  For example:
  
  
  ```
  curl -X GET "${ES_URL}/_cat/indices?v=true" \
    -H "Authorization: ApiKey ${API_KEY}"
  ```
  
  To get API keys, use the `/_security/api_key` APIs.
- Basic: `Authorization: Basic <credentials>`
- Bearer: `Authorization: Bearer <token>`
  Elasticsearch APIs support the use of bearer tokens in the `Authorization` HTTP header to authenticate with the API.
  For examples, refer to [Token-based authentication services](https://www.elastic.co/guide/en/elasticsearch/reference/current/token-authentication-services.html)

## Query string parameters

- `allow_no_indices` (boolean · default: true) — optional
  If `false`, the request returns an error if any wildcard expression, index alias, or `_all` value targets only missing or closed indices.
This behavior applies even if the request targets other open indices.
- `expand_wildcards` (string · default: open) — optional
  Type of index that wildcard patterns can match.
If the request can target data streams, this argument determines whether wildcard expressions match hidden data streams.
Supports comma-separated values, such as `open,hidden`.

Supported values include:
  - `all`: Match any data stream or index, including hidden ones.
  - `open`: Match open, non-hidden indices. Also matches any non-hidden data stream.
  - `closed`: Match closed, non-hidden indices. Also matches any non-hidden data stream. Data streams cannot be closed.
  - `hidden`: Match hidden data streams and hidden indices. Must be combined with `open`, `closed`, or `both`.
  - `none`: Wildcard expressions are not accepted.
  Values: `all`, `open`, `closed`, `hidden`, `none`
- `ignore_unavailable` (boolean · default: false) — optional
  If `false`, the request returns an error if it targets a missing or closed index.
- `master_timeout` (string · default: 30s) — optional
  Period to wait for a connection to the master node.
If no response is received before the timeout expires, the request fails and returns an error.
- `timeout` (string · default: 30s) — optional
  Period to wait for a response.
If no response is received before the timeout expires, the request fails and returns an error.
- `write_index_only` (boolean · default: false) — optional
  If `true`, the mappings are applied only to the current write index for the target.

## Request body

`application/json`

- `date_detection` (boolean) — optional
  Controls whether dynamic date detection is enabled.
- `dynamic` (enum) — optional
  Controls whether new fields are added dynamically.
  Values: `strict`, `runtime`, `true`, `false`
- `dynamic_date_formats` (string[]) — optional
  If date detection is enabled then new string fields are checked
against 'dynamic_date_formats' and if the value matches then
a new date field is added instead of string.
- `dynamic_templates` (string to object[]) — optional
  Specify dynamic templates for the mapping.
- `_field_names` (object) — optional
  Control whether field names are enabled for the index.
  - `enabled` (boolean) — required
- `_meta` (object) — optional
  A mapping type can have custom meta data associated with it. These are
not used at all by Elasticsearch, but can be used to store
application-specific metadata.
- `numeric_detection` (boolean · default: false) — optional
  Automatically map strings into numeric data types for all fields.
- `properties` (map string to oneOf) — optional
  Mapping for a field. For new fields, this mapping can include:

- Field name
- Field data type
- Mapping parameters
- `_routing` (object) — optional
  Enable making a routing value required on indexed documents.
  - `required` (boolean) — required
- `_source` (object) — optional
  Control whether the _source field is enabled on the index.
  - `compress` (boolean) — optional
  - `compress_threshold` (string) — optional
  - `enabled` (boolean) — optional
  - `excludes` (string[]) — optional
  - `includes` (string[]) — optional
  - `mode` (enum) — optional
    

Supported values include:
  - `disabled`
  - `stored`
  - `synthetic`: Instead of storing source documents on disk exactly as you send them,
 Elasticsearch can reconstruct source content on the fly upon retrieval.
    Values: `disabled`, `stored`, `synthetic`
- `runtime` (object) — optional
  Mapping of runtime fields for the index.

## Response

`application/json`

- `acknowledged` (boolean)
  For a successful response, this value is always true. On failure, an exception is returned instead.
- `_shards` (object)
  - `failed` (number)
    The number of shards the operation or search attempted to run on but failed.
  - `successful` (number)
    The number of shards the operation or search succeeded on.
  - `total` (number)
    The number of shards the operation or search will run on overall.
  - `failures` (object[])
    - `index` (string)
    - `node` (string)
    - `reason` (object)
      - `type` (string)
        The type of error
      - `reason` (union string) — nullable
        A human-readable explanation of the error, in English.
        One of: `string`
      - `stack_trace` (string)
        The server stack trace. Present only if the `error_trace=true` parameter was sent with the request.
      - `caused_by` (object) — recursive
        Same fields as `reason` in `failures`
      - `root_cause` (object[]) — recursive
        Same fields as `reason` in `failures`
      - `suppressed` (object[]) — recursive
        Same fields as `reason` in `failures`
    - `shard` (number)
    - `status` (string)
    - `primary` (boolean)
  - `skipped` (number)
## Code examples

#### Console

```console
POST /my-index-000001/_mapping
{
  "properties": {
    "user": {
      "properties": {
        "name": {
          "type": "keyword"
        }
      }
    }
  }
}
```

#### JavaScript

```javascript
const response = await client.indices.putMapping({
  index: "my-index-000001",
  properties: {
    user: {
      properties: {
        name: {
          type: "keyword",
        },
      },
    },
  },
});
```

#### Python

```python
resp = client.indices.put_mapping(
    index="my-index-000001",
    properties={
        "user": {
            "properties": {
                "name": {
                    "type": "keyword"
                }
            }
        }
    },
)
```

#### curl

```curl
curl -X POST "$ELASTICSEARCH_URL/my-index-000001/_mapping" \
  -H "Authorization: ApiKey $ELASTIC_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "properties": {
      "user": {
        "properties": {
          "name": {
            "type": "keyword"
          }
        }
      }
    }
  }'
```

#### Java

```java
client.indices().putMapping(p -> p
    .index("my-index-000001")
    .properties("user", pr -> pr
        .object(o -> o
            .properties("name", pro -> pro
                .keyword(k -> k)
            )
        )
    )
);
```

#### C#

```c#
var response = await client.Indices
    .PutMappingAsync(indices: new[] { "my-index-000001" }, d1 => d1
        .Properties(d2 => d2
            .Object(x => x.User, d3 => d3
                .Properties(d4 => d4
                    .Keyword(x => x.Name)
                )
            )
        )
    );
```

#### PHP

```php
$resp = $client->indices()->putMapping([
    "index" => "my-index-000001",
    "body" => [
        "properties" => [
            "user" => [
                "properties" => [
                    "name" => [
                        "type" => "keyword",
                    ],
                ],
            ],
        ],
    ],
]);
```

#### Ruby

```ruby
response = client.indices.put_mapping(
  index: "my-index-000001",
  body: {
    "properties": {
      "user": {
        "properties": {
          "name": {
            "type": "keyword"
          }
        }
      }
    }
  }
)
```

